import * as _ from 'lodash';
function validataDataMapping(dataMapping) {
    if (_.isEmpty(dataMapping.column) || _.isEmpty(dataMapping.row)) {
        throw new Error('please set at least 1 column or row in dataMapping.');
    }
    var column = dataMapping.column, row = dataMapping.row;
    dataMapping.column = Array.isArray(column) ? column : [column];
    dataMapping.row = Array.isArray(row) ? row : [row];
    return dataMapping;
}
export var process = function (config) {
    var dataMapping = config.dataMapping;
    if (_.isEmpty(dataMapping)) {
        return config;
    }
    config.dataMapping = validataDataMapping(dataMapping);
    return config;
};
//# sourceMappingURL=setDataMappingConfig.js.map