'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.process = undefined;

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function validataDataMapping(dataMapping) {
    if ((0, _isEmpty3.default)(dataMapping.column) || (0, _isEmpty3.default)(dataMapping.row)) {
        throw new Error('please set at least 1 column or row in dataMapping.');
    }
    var column = dataMapping.column,
        row = dataMapping.row;
    dataMapping.column = Array.isArray(column) ? column : [column];
    dataMapping.row = Array.isArray(row) ? row : [row];
    return dataMapping;
}
var process = exports.process = function process(config) {
    var dataMapping = config.dataMapping;
    if ((0, _isEmpty3.default)(dataMapping)) {
        return config;
    }
    config.dataMapping = validataDataMapping(dataMapping);
    return config;
};
//# sourceMappingURL=setDataMappingConfig.js.map